#include"t10n_block.hpp"
#include"t10n_lexer.hpp"




namespace t10n{




Block::
Block(const std::string&  s)
{
  Position  pos;

  auto  p = s.data();

  Lexer(tokens_,pos,p,0);
}


Block::
Block(Bracket  bracket, Position&  pos, const char*&  p):
bracket_(bracket)
{
  Lexer(tokens_,pos,p,bracket.close);
}


Block::
Block(const Block&  rhs):
bracket_(rhs.bracket_),
tokens_(rhs.tokens_)
{
}


Block::
Block(Block&&  rhs):
bracket_(rhs.bracket_),
tokens_(std::move(rhs.tokens_))
{
}




TokenList&
Block::
get_token_list()
{
  return tokens_;
}


void
Block::
print(int  indent_n) const
{
    if(bracket_.open)
    {
      print_indent(indent_n);

      fputc(bracket_.open,stdout);

      printf("\n");
    }


    for(auto&  tok: tokens_)
    {
      tok.print(indent_n);

      printf("\n");
    }


    if(bracket_.close)
    {
      print_indent(indent_n);

      fputc(bracket_.close,stdout);

      printf("\n");
    }
}


}




