#ifndef T10N_BLOCK_HPP_INCLUDED
#define T10N_BLOCK_HPP_INCLUDED


#include"t10n_token.hpp"


namespace t10n{


struct
Bracket
{
  const int   open;
  const int  close;

  constexpr Bracket(int  op=0, int  cl=0): open(op), close(cl){}

};


using TokenList = std::list<Token>;


class
Block
{
  const Bracket  bracket_;

  TokenList  tokens_;

public:
  Block(const std::string&  s);
  Block(Bracket  bracket, Position&  pos, const char*&  p);
  Block(const Block&   rhs);
  Block(      Block&&  rhs);


  TokenList&  get_token_list();

  void  print(int  indent_n=0) const;

};


}




#endif




