#ifndef T10N_LEXER_HPP_INCLUDED
#define T10N_LEXER_HPP_INCLUDED


#include"t10n_token.hpp"
#include"t10n_block.hpp"
#include"t10n_operator.hpp"


#ifndef report
#define report  printf("[report in %s] %d %s\n",__FILE__,__LINE__,__func__);
#endif


namespace t10n{




class
Lexer
{
  const char*&  pointer_;

  Position&  position_;

  TokenList&  tokens_;

  std::string  buffer_;


  void  newline();
  void  advance(uint32_t  n=1);

  void  skip_spaces();
  void  skip_line_comment();
  void  skip_block_comment();

  void  read_str_literal(const Position&  pos, TokenType  type, const int  close_chr);

  void  read_binint_literal(const Position&  pos);
  void  read_hexint_literal(const Position&  pos);
  void  read_int_literal(const Position&  pos);

  void  read_operator(const Position&  pos);

  void  read_identifier(const Position&  pos, int  first_c);

public:
  Lexer(TokenList&  tokens, Position&  position, const char*&  pointer, const int  close);

};


}




#endif




