#include"t10n_lexer.hpp"




namespace t10n{




void
Lexer::
read_binint_literal(const Position&  pos)
{
  unsigned int  i = 0;

    for(;;)
    {
      const int  c = *pointer_;

        if((c == '0') ||
           (c == '1'))
        {
          advance();

          i <<= 1;

            if(c == '1')
            {
              i |= 1;
            }
        }

      else
        {
          break;
        }
    }


  tokens_.emplace_back(pos,TokenType::int_literal,i);
}


void
Lexer::
read_hexint_literal(const Position&  pos)
{
  unsigned int  i = 0;

    for(;;)
    {
      const int  c = *pointer_;

        if(isxdigit(c))
        {
          advance();

          i <<= 4;

            switch(c)
            {
              case('1'): i |=  1;break;
              case('2'): i |=  2;break;
              case('3'): i |=  3;break;
              case('4'): i |=  4;break;
              case('5'): i |=  5;break;
              case('6'): i |=  6;break;
              case('7'): i |=  7;break;
              case('8'): i |=  8;break;
              case('9'): i |=  9;break;
              case('A'): i |= 10;break;
              case('B'): i |= 11;break;
              case('C'): i |= 12;break;
              case('D'): i |= 13;break;
              case('E'): i |= 14;break;
              case('F'): i |= 15;break;
            }
        }

      else
        {
          break;
        }
    }


  tokens_.emplace_back(pos,TokenType::int_literal,i);
}


void
Lexer::
read_int_literal(const Position&  pos)
{
    if(pointer_[0] == '0')
    {
        if(pointer_[1] == 'x')
        {
          advance(2);

          read_hexint_literal(pos);

          return;
        }

      else
        if(pointer_[1] == 'b')
        {
          advance(2);

          read_binint_literal(pos);

          return;
        }


      advance();

      tokens_.emplace_back(pos,TokenType::int_literal,0);
    }

  else
    {
      unsigned int  i = 0;

        for(;;)
        {
          const int  c = *pointer_;

            if(isdigit(c))
            {
              advance();

              i *= 10;

                switch(c)
                {
                  case('1'): i +=  1;break;
                  case('2'): i +=  2;break;
                  case('3'): i +=  3;break;
                  case('4'): i +=  4;break;
                  case('5'): i +=  5;break;
                  case('6'): i +=  6;break;
                  case('7'): i +=  7;break;
                  case('8'): i +=  8;break;
                  case('9'): i +=  9;break;
                }
            }

          else
            {
              break;
            }
        }


      tokens_.emplace_back(pos,TokenType::int_literal,i);
    }
}




}




